﻿Module G2g

    Dim fw() As Double, sm() As Double, p(,) As Double, q(,) As Double, s(,) As Double, hb() As Double
    Dim alm() As Double, amu() As Double, ab() As Double, as1() As Double
    Dim ag(4, 4) As Double

    Sub Grid2Grid(ByVal Nx As Long, ByVal Ny As Long, ByVal NxG As Long, ByVal NyG As Long, _
    ByVal Xmin As Double, ByVal Ymin As Double, ByVal XminG As Double, ByVal YminG As Double, _
    ByVal Dx As Double, ByVal Dy As Double, ByVal DxG As Double, ByVal DyG As Double, _
    ByVal Xg() As Double, ByVal Yg() As Double, ByRef gd(,) As Double, _
    ByRef h(,) As Double, ByRef ImR(,) As Integer, ByRef ImG(,) As Integer, ByRef ImB(,) As Integer)

        Dim aa(4, 4) As Double, bb(4, 4) As Double, ck(4, 4) As Double
        Dim gm(4, 4) As Double, Xm(4) As Double, Yn(4) As Double

        Dim k As Long, kk As Long
        Dim k1 As Long, k2 As Long
        Dim L As Long, LL As Long
        Dim L1 As Long, L2 As Long
        Dim ikg As Long, jkg As Long
        Static i As Long, j As Long
        Dim m As Long, N As Long
        Dim xx As Double, yy As Double
        Dim i1 As Long, i2 As Long, j1 As Long, j2 As Long
        Dim XmaxG As Double, YmaxG As Double

        Dim Max_xy As Long, Max_nx As Long, Max_ny As Long

        XmaxG = XminG + (NxG - 1) * DxG
        YmaxG = YminG + (NyG - 1) * DyG

        Max_nx = Nx
        If Max_nx < NxG Then Max_nx = NxG
        Max_ny = Ny
        If Max_ny < NyG Then Max_ny = NyG
        Max_xy = Max_nx
        If Max_xy < Max_ny Then Max_xy = Max_ny

        ReDim fw(Max_xy + 1), sm(Max_xy + 1), hb(Max_xy + 1)
        ReDim gd(Max_nx, Max_ny)
        ReDim p(Max_nx + 1, Max_ny + 1), q(Max_nx + 1, Max_ny + 1), s(Max_nx + 1, Max_ny + 1)
        ReDim alm(Max_xy + 1), amu(Max_xy + 1), ab(Max_xy + 1), as1(Max_xy + 1)

        derxy(Nx, Ny, Xg, Yg, h)

        '範囲指定
        FLMTx(Xg, XminG, i1, Nx)
        FLMTx(Xg, XmaxG, i2, Nx)
        FLMTy(Yg, YminG, j1, Ny)
        FLMTy(Yg, YmaxG, j2, Ny)

        k1 = 1
        For i = i1 To i2
            k2 = Int((Xg(i + 1) - XminG) / DxG + 1.0001)
            If i = i2 Then k2 = NxG
            If k2 < k1 Then GoTo 1

            L1 = 1
            For j = j1 To j2
                L2 = Int((Yg(j + 1) - YminG) / DyG + 1.0001)
                If j = j2 Then L2 = NyG
                If L2 < L1 Then GoTo 2

                ' parameter gm(m,n) for this grid (i,j)
                ' gm(m, n) = aa(m, l) * ck(l, k) * bb(n, k)
                mata(Dx)
                For ikg = 1 To 4
                    For jkg = 1 To 4
                        aa(ikg, jkg) = ag(ikg, jkg)
                    Next
                Next

                mata(Dy)
                For ikg = 1 To 4
                    For jkg = 1 To 4
                        bb(ikg, jkg) = ag(ikg, jkg)
                    Next
                Next
                '
                For k = 1 To 2
                    kk = i + k - 1
                    For L = 1 To 2
                        LL = j + L - 1
                        ck(2 * k - 1, 2 * L - 1) = h(kk, LL)
                        ck(2 * k - 1, 2 * L) = q(kk, LL)
                        ck(2 * k, 2 * L - 1) = p(kk, LL)
                        ck(2 * k, 2 * L) = s(kk, LL)
                    Next
                Next
                '
                For m = 1 To 4
                    For N = 1 To 4
                        gm(m, N) = 0
                        For L = 1 To 4
                            For k = 1 To 4
                                gm(m, N) = gm(m, N) + aa(m, L) * ck(L, k) * bb(N, k)
                            Next k
                        Next L
                    Next N
                Next m
                '
                ' calculation of a value gd(k,l)
                For k = k1 To k2
                    xx = XminG + (k - 1) * DxG - Xg(i)
                    Xm(1) = 1
                    For m = 2 To 4
                        Xm(m) = xx * Xm(m - 1)
                    Next m
                    For L = L1 To L2
                        yy = YminG + (L - 1) * DyG - Yg(j)
                        Yn(1) = 1
                        For N = 2 To 4
                            Yn(N) = yy * Yn(N - 1)
                        Next N
                        gd(k, L) = 0
                        For m = 1 To 4
                            For N = 1 To 4
                                gd(k, L) = gd(k, L) + gm(m, N) * Xm(m) * Yn(N)
                            Next
                        Next
                    Next
                Next
                L1 = L2 + 1
2:          Next j
            k1 = k2 + 1
1:      Next i

        '変換後の格子データを使う
        Erase h
        ReDim h(Max_nx, Max_ny)
        Erase ImR, ImG, ImB
        If Max_nx < 256 Then
            ReDim ImR(256, Max_ny)
            ReDim ImG(256, Max_ny)
            ReDim ImB(256, Max_ny)
        Else
            ReDim ImR(Max_nx, Max_ny)
            ReDim ImG(Max_nx, Max_ny)
            ReDim ImB(Max_nx, Max_ny)
        End If

        Erase fw, sm, p, q, s, hb

    End Sub

    Private Sub FLMTx(ByVal Xg() As Double, ByVal Xi As Double, ByRef i1 As Long, ByVal NxyG As Long)

        Dim ilmt As Long

        For ilmt = 2 To NxyG
            If Xi < Xg(ilmt) Then GoTo 110
        Next

110:    i1 = ilmt - 1

    End Sub

    Private Sub FLMTy(ByVal Yg() As Double, ByVal Yi As Double, ByRef j1 As Long, ByVal NxyG As Long)

        Dim jlmt As Long

        For jlmt = 2 To NxyG
            If Yi < Yg(jlmt) Then GoTo 110
        Next

110:    j1 = jlmt - 1

    End Sub

    Private Sub derv1(ByVal c1 As Double, ByVal cn As Double, ByVal N As Long)
        '
        '     first derivatives sm(i)=df/dx    for (x,f)
        '     equations (33) and (35) in ichida & yoshimoto(1979)

        Dim N1 As Long, k1 As Long
        Dim smm As Double
        Dim i As Long, k As Long

        N1 = N - 1
        For i = 2 To N1
            smm = alm(i) * (fw(i) - fw(i - 1)) / hb(i) + amu(i) * (fw(i + 1) - fw(i)) / hb(i + 1)
            sm(i) = 3 * smm
        Next
        sm(1) = c1
        sm(N) = cn
        For k = 2 To N
            sm(k) = sm(k) - as1(k) * sm(k - 1)
        Next
        sm(N) = sm(N) / ab(N)
        For k = 1 To N1
            k1 = N1 - k + 1
            sm(k1) = (sm(k1) - amu(k1) * sm(k1 + 1)) / ab(k1)
        Next

    End Sub

    Private Sub derxy(ByVal Nx As Long, ByVal Ny As Long, ByVal Xg() As Double, ByVal Yg() As Double, ByVal h(,) As Double)

        '     caluculation of derivatives (p,q,s)
        '     p=df/dx  q=df/dy  s=ddf/dxdy

        Dim c1 As Double
        Dim cn As Double
        Static i As Long, j As Long

        ' for p
        parpqx(Nx, Xg, 2, 2)
        For j = 1 To Ny
            For i = 1 To Nx
                fw(i) = h(i, j)
            Next
            c1 = 4 * (fw(2) - fw(1)) / hb(2)
            cn = 4 * (fw(Nx) - fw(Nx - 1)) / hb(Nx)
            derv1(c1, cn, Nx)
            For i = 1 To Nx
                p(i, j) = sm(i)
            Next
        Next
        ' for q
        parpqy(Ny, Yg, 2, 2)
        For i = 1 To Nx
            For j = 1 To Ny
                fw(j) = h(i, j)
            Next
            c1 = 4 * (fw(2) - fw(1)) / hb(2)
            cn = 4 * (fw(Ny) - fw(Ny - 1)) / hb(Ny)
            derv1(c1, cn, Ny)
            For j = 1 To Ny
                q(i, j) = sm(j)
            Next
        Next
        ' for s(i,j)
        parpqx(Nx, Xg, 2, 2)
        j = 2 - Ny
300:    j = j + Ny - 1
        For i = 1 To Nx
            fw(i) = q(i, j)
        Next
        c1 = 4 * (fw(2) - fw(1)) / hb(2)
        cn = 4 * (fw(Nx) - fw(Nx - 1)) / hb(Nx)
        derv1(c1, cn, Nx)
        For i = 1 To Nx
            s(i, j) = sm(i)
        Next
        If j = 1 Then GoTo 300
        '
        parpqy(Ny, Yg, 0, 0)
        For i = 1 To Nx
            For j = 1 To Ny
                fw(j) = p(i, j)
            Next
            c1 = s(i, 1)
            cn = s(i, Ny)
            derv1(c1, cn, Ny)
            For j = 1 To Ny
                s(i, j) = sm(j)
            Next
        Next

    End Sub

    Private Sub mata(ByVal dh As Double)

        '     modified equation (29) in ichida and yoshimoto(1979)

        Dim r As Double, rr As Double, rrr As Double
        Dim i As Long, j As Long

        r = 1 / dh
        rr = r / dh
        rrr = rr / dh
        For i = 1 To 2
            For j = 1 To 4
                ag(i, j) = 0
            Next
        Next
        ag(1, 1) = 1
        ag(2, 2) = 1
        ag(3, 1) = -3 * rr
        ag(3, 2) = -2 * r
        ag(3, 3) = -ag(3, 1)
        ag(3, 4) = -r
        ag(4, 1) = 2 * rrr
        ag(4, 2) = rr
        ag(4, 3) = -2 * rrr
        ag(4, 4) = rr

    End Sub

    Private Sub parpqx(ByVal Nx As Long, ByVal Xg() As Double, ByVal amu1 As Double, ByVal almn As Double)

        '     parameters h,alm,amu,as1,ab : (30) and (31) of 3-5 in i&y(1979)

        Dim N1 As Long
        Dim i As Long, k As Long

        N1 = Nx - 1
        For i = 2 To Nx
            hb(i) = Xg(i) - Xg(i - 1)
        Next

        amu(1) = amu1
        alm(Nx) = almn
        For i = 2 To N1
            alm(i) = hb(i + 1) / (hb(i) + hb(i + 1))
            amu(i) = 1 - alm(i)
        Next
        ab(1) = 2
        For k = 2 To Nx
            as1(k) = alm(k) / ab(k - 1)
            ab(k) = 2 - as1(k) * amu(k - 1)
        Next

    End Sub

    Private Sub parpqy(ByVal Ny As Long, ByVal Yg() As Double, ByVal amu1 As Double, ByVal almn As Double)

        '     parameters h,alm,amu,as1,ab : (30) and (31) of 3-5 in i&y(1979)

        Dim N1 As Long
        Dim i As Long, k As Long

        N1 = Ny - 1
        For i = 2 To Ny
            hb(i) = Yg(i) - Yg(i - 1)
        Next

        amu(1) = amu1
        alm(Ny) = almn
        For i = 2 To N1
            alm(i) = hb(i + 1) / (hb(i) + hb(i + 1))
            amu(i) = 1 - alm(i)
        Next
        ab(1) = 2
        For k = 2 To Ny
            as1(k) = alm(k) / ab(k - 1)
            ab(k) = 2 - as1(k) * amu(k - 1)
        Next

    End Sub

End Module
